program t_difx
implicit none

integer :: i, nx
real :: arg, dx, pi
real, allocatable, dimension (:) :: vin, vout, a
complex, allocatable, dimension (:) :: ckx

interface 
   subroutine wavnum(ck,n,d,iord)

     integer :: iord, n
     real :: d
     complex, dimension (:) :: ck
     
   end subroutine wavnum

   subroutine difx(vin, vout, ckx, nx)
     integer :: nx
     real, dimension (:) :: vin, vout
     complex, dimension (:) :: ckx
   end subroutine difx

end interface

nx=32 
pi = 4.*atan(1.)
dx = 2.*pi/nx

allocate(vin(nx), vout(nx), a(nx), ckx(nx))

call wavnum(ckx,nx,dx,1)

do i=1, nx
   arg = 2.*pi*(i-1)/nx
   vin(i) = sin(arg)
   a(i) = cos(arg)
end do

call difx(vin,vout,ckx,nx)

do i=1, nx
   print*,i,a(i),vout(i)
end do

end program t_difx
